{ Copyright (C) 1998-2000, written by Shkolnik Mike
  FIDOnet: 2:463/106.14
  E-Mail:  mshkolnik@scalabium.com
           mshkolnik@yahoo.com
  WEB: http://www.scalabium.com
       http://www.geocities.com/mshkolnik
  tel: 380-/44/-552-10-29

  In this unit I described the design-time editor for TSMLanguage component
}
unit SMLangR;

interface

uses Classes, DsgnIntf;

procedure Register;

implementation

{$R SMLANG.DCR}
uses Dialogs, TypInfo, SMLang;

type
  { TSMLanguageComponentEditor }
  TSMLanguageComponentEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  TSMLanguageFile = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;
begin
  RegisterComponents('SMComponents', [TSMLanguage]);
  RegisterComponentEditor(TSMLanguage, TSMLanguageComponentEditor);
  RegisterPropertyEditor(TypeInfo(string), TSMLanguage, 'ResourceFile', TSMLanguageFile);
end;


{ TSMLanguageComponentEditor }
procedure TSMLanguageComponentEditor.ExecuteVerb(Index: Integer);

  procedure ProcessComponent(AComponent: TComponent; Properties: TStrings; strParentName: string);
  var
    i, j: Integer;
    PropList: TPropList;
    PropInfo: PPropInfo;
  begin
    if not Assigned(AComponent) or (AComponent.Name = '') then exit;

    i := GetPropList(AComponent.ClassInfo, tkProperties, @PropList);
    for j := 0 to i-1 do
      if Properties.IndexOf(PropList[j].Name) < 0 then
      begin
        PropInfo := GetPropInfo(AComponent.ClassInfo, PropList[j].Name);
        if (PropInfo <> nil) then
          if (PropInfo^.PropType^^.Kind in [tkString, tkLString, tkWString{, tkInteger}]) then
            Properties.Add(strParentName + AComponent.Name + '.' + PropList[j].Name + ' = ' + GetStrProp(AComponent, PropInfo));
      end;

    for i := 0 to AComponent.ComponentCount-1 do
      ProcessComponent(AComponent.Components[i], Properties, AComponent.Name + '.');
  end;

begin
  with (Component as TSMLanguage) do
    case Index of
      0: begin
           with TSaveDialog.Create(nil) do
             try
               FileName := ResourceFile;
               Filter := 'Language files (*.lng)|(*.lng)|All files (*.*)|(*.*)';
               Options := [];
               if Execute then
                 SaveResources(FileName);
             finally
               Free
             end;
         end;
      1: begin
           with TOpenDialog.Create(nil) do
             try
               FileName := ResourceFile;
               Filter := 'Language files (*.lng)|(*.lng)|All files (*.*)|(*.*)';
               Options := [ofPathMustExist];
               if Execute then
                 LoadResources(FileName);
             finally
               Free
             end;
         end;
      2: begin
           Properties.Clear;
           Properties.Add('[Properties]');
           ProcessComponent(Owner, Properties, '');
         end;
    end
end;

function TSMLanguageComponentEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Generate language file...';
    1: Result := 'Load from language file...';
    2: Result := 'Generate Properties list'
  end;
end;

function TSMLanguageComponentEditor.GetVerbCount: Integer;
begin
  Result := 3;
end;


{ TSMLanguageFile }
procedure TSMLanguageFile.Edit;
begin
  with TOpenDialog.Create(nil) do
    try
      FileName := GetValue;
      Filter := 'Language files (*.lng)|(*.lng)|All files (*.*)|(*.*)';
      Options := [ofPathMustExist];
      if Execute then
        SetValue(FileName);
    finally
      Free
    end;
end;

function TSMLanguageFile.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;

end.